Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter minus : nat -> nat -> nat.
Parameter minus_body : nat -> nat -> nat.
Axiom axiom_minus : forall (n:nat), connectives.equal (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n).
Definition eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((axiom_minus) (n)).
Definition sym_eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) minus_body n) (minus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((eq_minus) (n)).
Axiom axiom_minus_body_O : connectives.equal (nat -> nat) (minus_body O) (fun (m:nat) => O).
Definition eq_minus_body_O : leibniz.leibniz (nat -> nat) (minus_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (axiom_minus_body_O).
Definition sym_eq_minus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (minus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (eq_minus_body_O).
Axiom axiom_minus_body_S : forall (n:nat), connectives.equal (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m).
Definition eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((axiom_minus_body_S) (n)).
Definition minus_S_S : forall (n:nat), forall (m:nat), logic.eq (nat) (minus (S n) (S m)) (minus n m) := fun (n:nat) => fun (m:nat) => ((((((eq_match_nat_type_S) (nat)) (S n)) (fun (q:nat) => minus n q)) (m)) (fun (y:nat) => logic.eq (nat) (minus (S n) (S m)) y)) ((((eq_minus_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) ((((((eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) ((((eq_minus) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) (((logic.refl) (nat)) (minus (S n) (S m)))))).
Definition minus_O_n : forall (n:nat), logic.eq (nat) O (minus O n) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) O (minus O __))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (fun (auto:nat) => ((logic.refl) (nat)) (O)))))) (n).
Definition minus_n_n : forall (n:nat), logic.eq (nat) O (minus n n) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) O (minus _x_365 _x_365))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus O O)) ((minus_O_n) (O)))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) O (minus x_366 x_366)) => (((((((logic.rewrite_r) (nat)) (minus x_366 x_366)) (fun (__:nat) => logic.eq (nat) O __)) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus x_366 x_366)) (_x_368))) (minus (S x_366) (S x_366))) (((minus_S_S) (x_366)) (x_366))))) (n).
